/**
 * DevOps API
 * Use the DevOps APIs to create a DevOps project to group the pipelines,  add reference to target deployment environments, add artifacts to deploy,  and create deployment pipelines needed to deploy your software.
 * OpenAPI spec version: 20210630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Information about the approval action of DevOps deployment stages.
 */
export interface ApprovalAction {
    /**
     * The subject ID of the user who approves or disapproves a DevOps deployment stage.
     */
    "subjectId": string;
    /**
     * The action of the user on the DevOps deployment stage.
     */
    "action": ApprovalAction.Action;
}
export declare namespace ApprovalAction {
    enum Action {
        Approve = "APPROVE",
        Reject = "REJECT",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: ApprovalAction): object;
}
