"use strict";
/**
 * DevOps API
 * Use the DevOps APIs to create a DevOps project to group the pipelines,  add reference to target deployment environments, add artifacts to deploy,  and create deployment pipelines needed to deploy your software.
 * OpenAPI spec version: 20210630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Deployment = void 0;
const model = __importStar(require("../model"));
var Deployment;
(function (Deployment) {
    let LifecycleState;
    (function (LifecycleState) {
        LifecycleState["Accepted"] = "ACCEPTED";
        LifecycleState["InProgress"] = "IN_PROGRESS";
        LifecycleState["Failed"] = "FAILED";
        LifecycleState["Succeeded"] = "SUCCEEDED";
        LifecycleState["Canceling"] = "CANCELING";
        LifecycleState["Canceled"] = "CANCELED";
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        LifecycleState["UnknownValue"] = "UNKNOWN_VALUE";
    })(LifecycleState = Deployment.LifecycleState || (Deployment.LifecycleState = {}));
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "deployPipelineArtifacts": obj.deployPipelineArtifacts
                ? model.DeployPipelineArtifactCollection.getJsonObj(obj.deployPipelineArtifacts)
                : undefined,
            "deployPipelineEnvironments": obj.deployPipelineEnvironments
                ? model.DeployPipelineEnvironmentCollection.getJsonObj(obj.deployPipelineEnvironments)
                : undefined,
            "deploymentArguments": obj.deploymentArguments
                ? model.DeploymentArgumentCollection.getJsonObj(obj.deploymentArguments)
                : undefined,
            "deployArtifactOverrideArguments": obj.deployArtifactOverrideArguments
                ? model.DeployArtifactOverrideArgumentCollection.getJsonObj(obj.deployArtifactOverrideArguments)
                : undefined,
            "deploymentExecutionProgress": obj.deploymentExecutionProgress
                ? model.DeploymentExecutionProgress.getJsonObj(obj.deploymentExecutionProgress)
                : undefined
        });
        if ("deploymentType" in obj && obj.deploymentType) {
            switch (obj.deploymentType) {
                case "PIPELINE_DEPLOYMENT":
                    return model.DeployPipelineDeployment.getJsonObj(jsonObj, true);
                case "PIPELINE_REDEPLOYMENT":
                    return model.DeployPipelineRedeployment.getJsonObj(jsonObj, true);
                case "SINGLE_STAGE_DEPLOYMENT":
                    return model.SingleDeployStageDeployment.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.deploymentType);
            }
        }
        return jsonObj;
    }
    Deployment.getJsonObj = getJsonObj;
})(Deployment = exports.Deployment || (exports.Deployment = {}));
//# sourceMappingURL=deployment.js.map