/**
 * DevOps API
 * Use the DevOps APIs to create a DevOps project to group the pipelines,  add reference to target deployment environments, add artifacts to deploy,  and create deployment pipelines needed to deploy your software.
 * OpenAPI spec version: 20210630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Description of rollout policy for load balancer traffic shift stage.
 */
export interface LoadBalancerTrafficShiftRolloutPolicy {
    /**
     * Specifies number of batches for this stage. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "batchCount": number;
    /**
     * Specifies delay in seconds between batches. The default delay is 1 minute. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "batchDelayInSeconds"?: number;
    /**
     * Indicates the criteria to stop. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "rampLimitPercent"?: number;
}
export declare namespace LoadBalancerTrafficShiftRolloutPolicy {
    function getJsonObj(obj: LoadBalancerTrafficShiftRolloutPolicy): object;
}
