"use strict";
/**
 * DevOps API
 * Use the DevOps APIs to create a DevOps project to group the pipelines,  add reference to target deployment environments, add artifacts to deploy,  and create deployment pipelines needed to deploy your software.
 * OpenAPI spec version: 20210630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateDeployStageDetails = void 0;
const model = __importStar(require("../model"));
var UpdateDeployStageDetails;
(function (UpdateDeployStageDetails) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "deployStagePredecessorCollection": obj.deployStagePredecessorCollection
                ? model.DeployStagePredecessorCollection.getJsonObj(obj.deployStagePredecessorCollection)
                : undefined
        });
        if ("deployStageType" in obj && obj.deployStageType) {
            switch (obj.deployStageType) {
                case "OKE_DEPLOYMENT":
                    return model.UpdateOkeDeployStageDetails.getJsonObj(jsonObj, true);
                case "LOAD_BALANCER_TRAFFIC_SHIFT":
                    return model.UpdateLoadBalancerTrafficShiftDeployStageDetails.getJsonObj(jsonObj, true);
                case "COMPUTE_INSTANCE_GROUP_ROLLING_DEPLOYMENT":
                    return model.UpdateComputeInstanceGroupDeployStageDetails.getJsonObj(jsonObj, true);
                case "WAIT":
                    return model.UpdateWaitDeployStageDetails.getJsonObj(jsonObj, true);
                case "MANUAL_APPROVAL":
                    return model.UpdateManualApprovalDeployStageDetails.getJsonObj(jsonObj, true);
                case "DEPLOY_FUNCTION":
                    return model.UpdateFunctionDeployStageDetails.getJsonObj(jsonObj, true);
                case "INVOKE_FUNCTION":
                    return model.UpdateInvokeFunctionDeployStageDetails.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.deployStageType);
            }
        }
        return jsonObj;
    }
    UpdateDeployStageDetails.getJsonObj = getJsonObj;
})(UpdateDeployStageDetails = exports.UpdateDeployStageDetails || (exports.UpdateDeployStageDetails = {}));
//# sourceMappingURL=update-deploy-stage-details.js.map