/**
 * Java Management Service Query API
 * API for the Java Management Service. Use this API to view and manage Fleets.
 * OpenAPI spec version: 20210610
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Application usage during a specified time period.
 * An application is a Java application that can be executed by a Java Runtime installation.
 * An application is independent of the Java Runtime or its installation.
 *
 */
export interface ApplicationUsage {
    /**
     * An internal identifier for the application that is unique to a Fleet.
     *
     */
    "applicationId": string;
    /**
     * The name of the application.
     */
    "displayName": string;
    /**
     * The type of the application, denoted by how the application was started.
     */
    "applicationType": string;
    /**
     * The approximate count of installations running this application. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "approximateInstallationCount"?: number;
    /**
     * The approximate count of Java Runtimes running this application. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "approximateJreCount"?: number;
    /**
     * The approximate count of managed instances reporting this application. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "approximateManagedInstanceCount"?: number;
    /**
     * Lower bound of the specified time period filter.
     */
    "timeStart"?: Date;
    /**
     * Upper bound of the specified time period filter.
     */
    "timeEnd"?: Date;
    /**
     * The date and time the resource was _first_ reported to JMS.
     * This is potentially _before_ the specified time period provided by the filters.
     * For example, a resource can be first reported to JMS before the start of a specified time period,
     * if it is also reported during the time period.
     *
     */
    "timeFirstSeen"?: Date;
    /**
     * The date and time the resource was _last_ reported to JMS.
     * This is potentially _after_ the specified time period provided by the filters.
     * For example, a resource can be last reported to JMS before the start of a specified time period,
     * if it is also reported during the time period.
     *
     */
    "timeLastSeen"?: Date;
}
export declare namespace ApplicationUsage {
    function getJsonObj(obj: ApplicationUsage): object;
}
