/**
 * Java Management Service Query API
 * API for the Java Management Service. Use this API to view and manage Fleets.
 * OpenAPI spec version: 20210610
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Parameters for filtering installations.
 */
export interface RequestSummarizedInstallationUsageDetails {
    /**
     * The start of the time period during which resources are searched (formatted according to RFC3339). Defaults to current time minus seven days.
     *
     */
    "timeStart"?: Date;
    /**
     * The end of the time period during which resources are searched (formatted according to RFC3339). Defaults to current time.
     *
     */
    "timeEnd"?: Date;
    /**
     * The path of the installation.
     */
    "installationPath"?: string;
    /**
     * The vendor of the related Java Runtime.
     */
    "jreVendor"?: string;
    /**
     * The distribution of the related Java Runtime.
     */
    "jreDistribution"?: string;
    /**
     * The version of the related Java Runtime.
     */
    "jreVersion"?: string;
    /**
     * The ID of the related application.
     */
    "applicationId"?: string;
    /**
     * The ID of the related managed instance.
     */
    "managedInstanceId"?: string;
    /**
     * The sort order to use, either 'asc' or 'desc'.
     */
    "sortOrder"?: model.SortOrder;
    /**
     * The field to sort installation views. Only one sort order may be provided.
     * Default order for _timeFirstSeen_, _timeLastSeen_, _jreVersion_, _approximateApplicationCount_
     * and _approximateManagedInstanceCount_  is **descending**.
     * Default order for _jreDistribution_ and _jreVendor_ is **ascending**. If no value is specified _timeLastSeen_ is default.
     *
     */
    "sortBy"?: model.InstallationSortBy;
    /**
     * Additional fields to include into the returned model on top of the required ones.
     * This parameter can also include 'approximateApplicationCount' and 'approximateManagedInstanceCount'.
     * For example 'approximateApplicationCount,approximateManagedInstanceCount'.
     *
     */
    "fields"?: Array<model.SummarizeInstallationUsageFields>;
}
export declare namespace RequestSummarizedInstallationUsageDetails {
    function getJsonObj(obj: RequestSummarizedInstallationUsageDetails): object;
}
